#!/usr/bin/perl -w
##
# Test rules for the test-assemble directory: nagative tests.
#
# These routines provide regression tests to ensure that the assemble
# routines generate the same results in repeated runs.
# We process the files in this directories:
#
#    *.fail.output
#        The file *.dasm is assembled and is expected to fail.
#        The result output is compared to this file to check that the
#        output does not change.
#        If they do not match, the differences are printed and we terminate.
#        This tests that the assembler is reporting errors as we expect.
#


##
# Assemble the .dasm file; comparing to the expectation.
addTest('name' => 'Assemble and fail',
        'input'    => '\.dasm$',
        'expect'   => '.fail.output',
        'generate' => sub {
                my ($directory, $input) = @_;

                my $cmd = "./dasm.pl -i $directory/$input";
                my ($rc, $output) = capture_output($cmd);

                return ($rc, $output, $cmd);
            },

        'compare' => \&comparefail,
       );

# Must return true
1;
