#!/usr/bin/perl -w
##
# Test rules for the test-cycles directory: positive tests of cycles
# taken for execution.
#
# We process the files in this directories:
#
#    *.expect.run
#        The file *.dasm is assembled and run. The output is captured
#        along with the cycle and instruction count.
#        The result is compared to this output.
#        If they do not match, the differences are printed and we terminate.
#        This tests that the instructions count cycles as expected.
#


##
# Assemble the .dasm file and run it, with the cycle counts enabled;
# comparing to the expectation.
addTest('name' => 'Assemble and run with cycle counts',
        'input'    => '(?<!expect)\.dasm$',
        'expect'   => '.expect.run',
        'generate' => sub {
                my ($directory, $input) = @_;

                my $cmd = "./dasm.pl -notimes -run -i $directory/$input";
                my ($rc, $output) = capture_output($cmd);

                return ($rc, $output, $cmd);
            },

        'compare' => \&compare,
       );


# Must return true
1;
