#!/usr/bin/perl -w
##
# Test rules for the test-dump directory: negative tests.
#
# These routines provide regression tests to ensure that the dump load
# routines generate the same results in repeated runs.
#
# We read .dump files and re-dump them. We expect this to fail, and record
# the results appropriately.
#
# We assemble .dasm files and try to dump it. We expect this to fail, and
# record the results appropriately.
#


##
# Load a .dump file, which should fail; comparing to the expectation.
addTest('name' => 'Load failures',
        'input'    => '.dump$',
        'expect'   => '.fail.output',
        'generate' => sub {
                my ($directory, $input) = @_;

                my $cmd = "./dasm.pl -o .dump -i $directory/$input";
                my ($rc, $output) = capture_output($cmd);

                return ($rc, $output, $cmd);
            },

        'compare' => \&comparefail,
       );

##
# Assemble a .dasm file, which should fail; comparing to the expectation.
addTest('name' => 'Save failures',
        'input'    => '.dasm$',
        'expect'   => '.fail.output',
        'generate' => sub {
                my ($directory, $input) = @_;

                my $cmd = "./dasm.pl -o .dump -i $directory/$input";
                my ($rc, $output) = capture_output($cmd);

                return ($rc, $output, $cmd);
            },

        'compare' => \&comparefail,
       );

1;
