#!/usr/bin/perl -w
##
# Test rules for the test-dump directory: positive tests.
#
# These routines provide regression tests to ensure that the dump load
# routines generate the same results in repeated runs.
#
# We read .dump files and re-dump them. The expectation is the standard
# format, and should appear consistent.
#


##
# Assemble the .dasm file and dump it; comparing to the expectation.
addTest('name' => 'Read and write',
        'input'    => '(?<!expect)\.dump$',
        'expect'   => '.expect.dump',
        'generate' => sub {
                my ($directory, $input) = @_;

                my $cmd = "./dasm.pl -o .dump -i $directory/$input";
                my ($rc, $output) = capture_output($cmd);

                return ($rc, $output, $cmd);
            },

        'compare' => \&compare,
       );

1;
