#!/usr/bin/perl -w
##
# Test rules for the test-execute directory: positive tests of execution
# and output.
#
#    *.expect.run
#        The file *.dasm is assembled and run. The output is captured,
#        along with the registers.
#        The result is compared to this output.
#        If they do not match, the differences are printed and we terminate.
#        This tests that the code execution is as expected - at least in
#        terms of the terminal registers.
#


##
# Assemble the .dasm file and run it, with the cycle counts enabled;
# comparing to the expectation.
addTest('name' => 'Assemble and run, checking output and registers',
        'input'    => '(?<!expect)\.dasm$',
        'expect'   => '.expect.run',
        'generate' => sub {
                my ($directory, $input) = @_;

                my $cmd = "./dasm.pl -showregs -nocounts -notimes -run -i $directory/$input";
                my ($rc, $output) = capture_output($cmd);

                return ($rc, $output, $cmd);
            },

        'compare' => \&compare,
       );


# Must return true
1;
